<?php

/**
 * GepReuniao
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     robertomartins - 29/07/2011 10:15:55 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepReuniao extends DaoGepReuniao
{


    /**    ok
     * Consulta dados de uma reuniao.
     *
     * @param integer $nrreuniao Numero da Sala.
     * @param integer $nrorg     Numero da Organizacao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaDadosReuniao($nrreuniao, $nrorg){

        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRREUNIAO = ?',
                array(
                 $nrorg,
                 $nrreuniao,
                )
            );
            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Consulta situacao da sala para um determinado periodo de datas.
     *
     * @param integer $nrsala    Numero da Sala.
     * @param string  $dataIni   Data de Inicio.
     * @param string  $dataFim   Data de Fim.
     * @param integer $nrorg     Numero da Organizacao.
     * @param integer $nrreuniao Numero da reuniao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaDadosByPeriodoDeDatas($nrsala, $dataIni, $dataFim, $nrorg, $nrreuniao){

        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRSALA = ? AND NRREUNIAO <> ? AND ((DTINICIOPLANEJADO BETWEEN ? AND ?) OR
                (DTFIMPLANEJADO BETWEEN ? AND ?))',
                array(
                 $nrorg,
                 $nrsala,
                 $nrreuniao,
                 $dataIni,
                 $dataFim,
                 $dataIni,
                 $dataFim,
                )
            );
            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Consulta reunioes por sala.
     *
     * @param integer $nrorg Numero da organizacao.
     * @param integer $sala  Numero da sala.
     *
     * @return Ambigous <boolean, NULL, TkModelEntity>|boolean
     */
    public static function consultaDadosBySala($nrorg, $sala) {
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND NRSALA = ?',
                array(
                 $nrorg,
                 $sala,
                )
            );
            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Pesquisa reunioes por periodo.
     *
     * @param integer $nrorg     Numero da organizacao.
     * @param integer $sala      Codigo da sala.
     * @param string  $dt_inicio Data de inicio.
     * @param string  $dt_fim    Data de fim.
     *
     * @return Ambigous <multitype:, TkModelEntity>|boolean
     */
    public static function reunioesByPeriodoSala($nrorg, $sala, $dt_inicio, $dt_fim){
        try {
            /*
            $db = TkDbAdapter::getWorkConnection();
            */

            $sql = "SELECT COUNT(CO.NRCONVOCADOREUNIAO), CO.NRREUNIAO, SA.QTMAXIMAPESSOAS
                      FROM GER_SALA SA, GEP_CONVOCADOREUNIAO CO
                     WHERE CO.NRREUNIAO IN (SELECT RE.NRREUNIAO
                                           FROM GEP_REUNIAO RE
                                          WHERE ((RE.DTINICIOPLANEJADO BETWEEN '$dt_inicio' AND '$dt_fim')
                                             OR (RE.DTFIMPLANEJADO BETWEEN '$dt_inicio' and '$dt_fim'))
                                            AND RE.NRSALA = $sala
                                            AND RE.NRORG = $nrorg)
                       AND CO.NRORG = $nrorg
                       AND SA.NRSALA = $sala
                       AND SA.NRORG = CO.NRORG
                  GROUP BY CO.NRREUNIAO, SA.QTMAXIMAPESSOAS";

            $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
            $qtd_reuniao = self::createObjectsFromArray($resultado);

            /*
            $resultado = $db->fetchAll($sql);
            $qtd_reuniao = self::createObjectsFromArray($resultado);
            */

            return $qtd_reuniao;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Retorna as reunioes realizadas pelo operador na data anterior a do sistema.
     *
     * @param integer $nrorg    Numero da organizacao.
     * @param integer $operador Numero do operador.
     * @param date    $data     Data atual no sistema.
     *
     * @return Ambigous <NULL, TkModelEntity>|boolean
     */

    public static function consultaReunioesRealizadasByOperador($nrorg,$operador,date $data){
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ?
                AND CDOPERINCLUSAO = ?
                AND DTFIMPLANEJADO < ?',
                array(
                 $nrorg,
                 $operador,
                 $data,
                )
            );
            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Metodo para retornar as reunioes com o operador informado.
     *
     * @param integer $nrorg    Numero da organizacao.
     * @param integer $operador Numero do operador.
     *
     * @return Ambigous <NULL, TkModelEntity>|boolean
     */
    public static function consultaReunioesByOperador($nrorg,$operador){
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ?
                AND CDOPERINCLUSAO = ?',
                array(
                 $nrorg,
                 $operador,
                )
            );
            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Metodo para consultar os valores da tela de reuni�o.
     *
     * @return string
     */
    public static function consultaReunioes() {
        $sql = "SELECT GEP_REUNIAO.NRREUNIAO AS \"NRREUNIAO\",
                  CASE
                    WHEN QTHORASPLANEJADA IS NULL
                    THEN ' '
                    ELSE concat(concat(lpad(floor(qthorasplanejada), 2, 0),':'),
                    lpad(ceil((qthorasplanejada - floor(qthorasplanejada)) * 60), 2, 0))
                  END                             AS \"QTHORASPLANEJADA_LABEL\",
                  GEP_REUNIAO.IDATIVO             AS \"IDATIVO\",
                  GEP_REUNIAO.NRTIPOREUNIAO       AS \"NRTIPOREUNIAO\",
                  GEP_REUNIAO.NRSALA              AS \"NRSALA\",
                  GEP_REUNIAO.DSREFERENCIAREUNIAO AS \"DSREFERENCIAREUNIAO\",
                  GEP_REUNIAO.DTINICIOPLANEJADO   AS \"DTINICIOPLANEJADO\",
                  GEP_REUNIAO.DTFIMPLANEJADO      AS \"DTFIMPLANEJADO\",
                  GEP_REUNIAO.DTINICIOREALIZADO   AS \"DTINICIOREALIZADO\",
                  GEP_REUNIAO.DTFIMREALIZADO      AS \"DTFIMREALIZADO\",
                  GEP_REUNIAO.QTHORASPLANEJADA    AS \"QTHORASPLANEJADA\",
                  GEP_REUNIAO.NRORG               AS \"NRORG\",
                  GEP_REUNIAO.DTINCLUSAO          AS \"DTINCLUSAO\",
                  GEP_REUNIAO.CDOPERINCLUSAO      AS \"CDOPERINCLUSAO\",
                  GEP_REUNIAO.NRORGINCLUSAO       AS \"NRORGINCLUSAO\",
                  GEP_REUNIAO.DTULTATU            AS \"DTULTATU\",
                  GEP_REUNIAO.CDOPERULTATU        AS \"CDOPERULTATU\",
                  GEP_REUNIAO.NRORGULTATU         AS \"NRORGULTATU\",
                  GER_SALA.NMSALA NRSALA__LABEL,
                  INCLUSAO.NMOPERADOR CDOPERINCLUSAO__LABEL,
                  INCLUSAO.NRPARCNEGOCIO CDOPERINCLUSAO__LABEL,
                  ATUALIZACAO.NMOPERADOR CDOPERULTATU__LABEL,
                  ATUALIZACAO.NRPARCNEGOCIO CDOPERULTATU__LABEL
                FROM GEP_REUNIAO
                LEFT JOIN GER_SALA
                ON GER_SALA.NRSALA = GEP_REUNIAO.NRSALA
                INNER JOIN OPERADOR INCLUSAO
                ON INCLUSAO.CDOPERADOR = GEP_REUNIAO.CDOPERINCLUSAO
                AND INCLUSAO.NRORG     = GEP_REUNIAO.NRORG
                INNER JOIN OPERADOR ATUALIZACAO
                ON ATUALIZACAO.CDOPERADOR = GEP_REUNIAO.CDOPERULTATU
                AND ATUALIZACAO.NRORG     = GEP_REUNIAO.NRORG
                WHERE WHERE_PLACEHOLDER
                AND FILTER_PLACEHOLDER
                ORDER BY NRREUNIAO DESC";
        return $sql;
    }


}
