/*
   Tabela ENDEFILI: Cadastro de Endereo da Filial
   Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela de ENDEFILI.
   Objetivo: Gerar log de alteraes realizadas na tabela de ENDEFILI, utilizando a tabela geral de Logs
   de Operaes.
*/

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_GER_ENDEFILI' AND
                TYPE   = 'TR'               AND
                U.UID  = O.UID              AND
                U.NAME = USER)
DROP TRIGGER LOG_GER_ENDEFILI
GO

CREATE TRIGGER LOG_GER_ENDEFILI
ON ENDEFILI
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_TIPO                VARCHAR(1);
   DECLARE @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE @V_DSSERVERRDM         VARCHAR(20);
   DECLARE @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE @V_DSREMOTEOPER        VARCHAR(12);
   DECLARE @V_DESC                VARCHAR(500);
   DECLARE @V_CDFILLOGOPER        VARCHAR(4);
   DECLARE @V_ITPESQ              VARCHAR(40);
   DECLARE @V_NMOPERADOR          VARCHAR(40);
   DECLARE @V_DSTPENDEFILI        VARCHAR(20);

   /*VARIAVEIS DO C_CURSOR*/
   DECLARE @V_IDCOMANDO           VARCHAR(1);
   DECLARE @V_NEW_CDFILIAL        VARCHAR(4);
   DECLARE @V_NEW_IDTPENDEFILI    VARCHAR(1);
   DECLARE @V_NEW_DSENDEFILISEP   VARCHAR(40);
   DECLARE @V_NEW_NRENDEFILISEP   VARCHAR(5);
   DECLARE @V_NEW_DSCOMPENDFIL    VARCHAR(200);
   DECLARE @V_NEW_CDLOGRADOURO    VARCHAR(4);
   DECLARE @V_NEW_CDPAIS          VARCHAR(4);
   DECLARE @V_NEW_SGESTADO        VARCHAR(2);
   DECLARE @V_NEW_CDMUNICIPIO     VARCHAR(4);
   DECLARE @V_NEW_NRCEPFILI       VARCHAR(15);
   DECLARE @V_NEW_NMCONTFILI      VARCHAR(40);
   DECLARE @V_NEW_DSEMAILFILI     VARCHAR(40);
   DECLARE @V_NEW_NRDDDFAXFILI    VARCHAR(3);
   DECLARE @V_NEW_NRFAXFILISEP    VARCHAR(12)
   DECLARE @V_NEW_NRRAMALFAXFILI  VARCHAR(4);
   DECLARE @V_NEW_NRDDDTELEFILI   VARCHAR(3);
   DECLARE @V_NEW_NRTELEFILISEP   VARCHAR(12);
   DECLARE @V_NEW_NRRAMALFILI     VARCHAR(4);
   DECLARE @V_NEW_NRDDDTELEXFILI  VARCHAR(3);
   DECLARE @V_NEW_NRTELEXFILISEP  VARCHAR(12);
   DECLARE @V_NEW_NRRAMTELEXFILI  VARCHAR(4);
   DECLARE @V_NEW_DSEMAILEMXMLNFE VARCHAR(120);

   DECLARE @V_OLD_CDFILIAL        VARCHAR(4);
   DECLARE @V_OLD_IDTPENDEFILI    VARCHAR(1);
   DECLARE @V_OLD_DSENDEFILISEP   VARCHAR(40);
   DECLARE @V_OLD_NRENDEFILISEP   VARCHAR(5);
   DECLARE @V_OLD_DSCOMPENDFIL    VARCHAR(200);
   DECLARE @V_OLD_CDLOGRADOURO    VARCHAR(4);
   DECLARE @V_OLD_CDPAIS          VARCHAR(4);
   DECLARE @V_OLD_SGESTADO        VARCHAR(2);
   DECLARE @V_OLD_CDMUNICIPIO     VARCHAR(4);
   DECLARE @V_OLD_NRCEPFILI       VARCHAR(15);
   DECLARE @V_OLD_NMCONTFILI      VARCHAR(40);
   DECLARE @V_OLD_DSEMAILFILI     VARCHAR(40);
   DECLARE @V_OLD_NRDDDFAXFILI    VARCHAR(3);
   DECLARE @V_OLD_NRFAXFILISEP    VARCHAR(12)
   DECLARE @V_OLD_NRRAMALFAXFILI  VARCHAR(4);
   DECLARE @V_OLD_NRDDDTELEFILI   VARCHAR(3);
   DECLARE @V_OLD_NRTELEFILISEP   VARCHAR(12);
   DECLARE @V_OLD_NRRAMALFILI     VARCHAR(4);
   DECLARE @V_OLD_NRDDDTELEXFILI  VARCHAR(3);
   DECLARE @V_OLD_NRTELEXFILISEP  VARCHAR(12);
   DECLARE @V_OLD_NRRAMTELEXFILI  VARCHAR(4);
   DECLARE @V_OLD_DSEMAILEMXMLNFE VARCHAR(120);

BEGIN
   /* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_TIPO         = '0';
   SET @V_DESC         = '';
   SET @V_ITPESQ       = '';
   SET @V_NMOPERADOR   = '';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT 'D' IDCOMANDO,
             CDFILIAL,
             IDTPENDEFILI,
             DSENDEFILISEP,
             NRENDEFILISEP,
             DSCOMPENDFIL,
             CDLOGRADOURO,
             CDPAIS,
             SGESTADO,
             CDMUNICIPIO,
             NRCEPFILI,
             NMCONTFILI,
             DSEMAILFILI,
             NRDDDFAXFILI,
             NRFAXFILISEP,
             NRRAMALFAXFILI,
             NRDDDTELEFILI,
             NRTELEFILISEP,
             NRRAMALFILI,
             NRDDDTELEXFILI,
             NRTELEXFILISEP,
             NRRAMTELEXFILI,
             DSEMAILEMXMLNFE,

             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL
      FROM
         DELETED
      WHERE
         CDFILIAL NOT IN (SELECT CDFILIAL FROM INSERTED)
      UNION ALL

      SELECT 'U' IDCOMANDO,
             DELETED.CDFILIAL,
             DELETED.IDTPENDEFILI,
             DELETED.DSENDEFILISEP,
             DELETED.NRENDEFILISEP,
             DELETED.DSCOMPENDFIL,
             DELETED.CDLOGRADOURO,
             DELETED.CDPAIS,
             DELETED.SGESTADO,
             DELETED.CDMUNICIPIO,
             DELETED.NRCEPFILI,
             DELETED.NMCONTFILI,
             DELETED.DSEMAILFILI,
             DELETED.NRDDDFAXFILI,
             DELETED.NRFAXFILISEP,
             DELETED.NRRAMALFAXFILI,
             DELETED.NRDDDTELEFILI,
             DELETED.NRTELEFILISEP,
             DELETED.NRRAMALFILI,
             DELETED.NRDDDTELEXFILI,
             DELETED.NRTELEXFILISEP,
             DELETED.NRRAMTELEXFILI,
             DELETED.DSEMAILEMXMLNFE,

             INSERTED.CDFILIAL,
             INSERTED.IDTPENDEFILI,
             INSERTED.DSENDEFILISEP,
             INSERTED.NRENDEFILISEP,
             INSERTED.DSCOMPENDFIL,
             INSERTED.CDLOGRADOURO,
             INSERTED.CDPAIS,
             INSERTED.SGESTADO,
             INSERTED.CDMUNICIPIO,
             INSERTED.NRCEPFILI,
             INSERTED.NMCONTFILI,
             INSERTED.DSEMAILFILI,
             INSERTED.NRDDDFAXFILI,
             INSERTED.NRFAXFILISEP,
             INSERTED.NRRAMALFAXFILI,
             INSERTED.NRDDDTELEFILI,
             INSERTED.NRTELEFILISEP,
             INSERTED.NRRAMALFILI,
             INSERTED.NRDDDTELEXFILI,
             INSERTED.NRTELEXFILISEP,
             INSERTED.NRRAMTELEXFILI,
             INSERTED.DSEMAILEMXMLNFE
      FROM
         INSERTED, DELETED
      WHERE
         INSERTED.CDFILIAL = DELETED.CDFILIAL
      UNION ALL

      SELECT 'I' IDCOMANDO,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,

             CDFILIAL,
             IDTPENDEFILI,
             DSENDEFILISEP,
             NRENDEFILISEP,
             DSCOMPENDFIL,
             CDLOGRADOURO,
             CDPAIS,
             SGESTADO,
             CDMUNICIPIO,
             NRCEPFILI,
             NMCONTFILI,
             DSEMAILFILI,
             NRDDDFAXFILI,
             NRFAXFILISEP,
             NRRAMALFAXFILI,
             NRDDDTELEFILI,
             NRTELEFILISEP,
             NRRAMALFILI,
             NRDDDTELEXFILI,
             NRTELEXFILISEP,
             NRRAMTELEXFILI,
             DSEMAILEMXMLNFE
      FROM INSERTED
      WHERE CDFILIAL NOT IN (SELECT CDFILIAL FROM DELETED);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                    @V_OLD_CDFILIAL,       @V_OLD_IDTPENDEFILI, @V_OLD_DSENDEFILISEP,  @V_OLD_NRENDEFILISEP,
                                    @V_OLD_DSCOMPENDFIL,   @V_OLD_CDLOGRADOURO, @V_OLD_CDPAIS,         @V_OLD_SGESTADO,
                                    @V_OLD_CDMUNICIPIO,    @V_OLD_NRCEPFILI,    @V_OLD_NMCONTFILI,     @V_OLD_DSEMAILFILI,
                                    @V_OLD_NRDDDFAXFILI,   @V_OLD_NRFAXFILISEP, @V_OLD_NRRAMALFAXFILI, @V_OLD_NRDDDTELEFILI,
                                    @V_OLD_NRTELEFILISEP,  @V_OLD_NRRAMALFILI,  @V_OLD_NRDDDTELEXFILI, @V_OLD_NRTELEXFILISEP,
                                    @V_OLD_NRRAMTELEXFILI, @V_OLD_DSEMAILEMXMLNFE,

                                    @V_NEW_CDFILIAL,       @V_NEW_IDTPENDEFILI, @V_NEW_DSENDEFILISEP,  @V_NEW_NRENDEFILISEP,
                                    @V_NEW_DSCOMPENDFIL,   @V_NEW_CDLOGRADOURO, @V_NEW_CDPAIS,         @V_NEW_SGESTADO,
                                    @V_NEW_CDMUNICIPIO,    @V_NEW_NRCEPFILI,    @V_NEW_NMCONTFILI,     @V_NEW_DSEMAILFILI,
                                    @V_NEW_NRDDDFAXFILI,   @V_NEW_NRFAXFILISEP, @V_NEW_NRRAMALFAXFILI, @V_NEW_NRDDDTELEFILI,
                                    @V_NEW_NRTELEFILISEP,  @V_NEW_NRRAMALFILI,  @V_NEW_NRDDDTELEXFILI, @V_NEW_NRTELEXFILISEP,
                                    @V_NEW_NRRAMTELEXFILI, @V_NEW_DSEMAILEMXMLNFE;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @V_IDCOMANDO = 'D' BEGIN /*DELETING*/
            IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CdFilial=' + @V_OLD_CDFILIAL;
            END;

            IF @V_OLD_IDTPENDEFILI IS NOT NULL BEGIN
               IF @V_OLD_IDTPENDEFILI = 'P' BEGIN
                  SET @V_DSTPENDEFILI = '-Principal';
               END
               ELSE IF @V_OLD_IDTPENDEFILI = 'C' BEGIN
                  SET @V_DSTPENDEFILI = '-Cobrana';
               END
               ELSE IF @V_OLD_IDTPENDEFILI = 'E' BEGIN
                  SET @V_DSTPENDEFILI = '-Exterior';
               END
               ELSE BEGIN
                  SET @V_DSTPENDEFILI = '-Exportao';
               END;
               SET @V_DESC = @V_DESC + ' TipoEnde=' + @V_OLD_IDTPENDEFILI + @V_DSTPENDEFILI;
            END;

            IF @V_OLD_DSENDEFILISEP	 IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DescEndereo=' + @V_OLD_DSENDEFILISEP;
            END;

            IF @V_OLD_NRENDEFILISEP	 IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Nmero=' + @V_OLD_NRENDEFILISEP;
            END;

            IF @V_OLD_DSCOMPENDFIL  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Complemento=' + @V_OLD_DSCOMPENDFIL;
            END;

            IF @V_OLD_CDLOGRADOURO  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Logradouro=' + @V_OLD_CDLOGRADOURO;
            END;

            IF @V_OLD_CDPAIS  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Pas=' + @V_OLD_CDPAIS;
            END;

            IF @V_OLD_SGESTADO  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SgEstado=' + @V_OLD_SGESTADO;
            END;

            IF @V_OLD_CDMUNICIPIO  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CdMunicpio=' + @V_OLD_CDMUNICIPIO;
            END;

            IF @V_OLD_NRCEPFILI  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Cep=' + @V_OLD_NRCEPFILI;
            END;

            IF @V_OLD_NMCONTFILI	 IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Contato=' + @V_OLD_NMCONTFILI;
            END;

            IF @V_OLD_DSEMAILFILI  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Email=' + @V_OLD_DSEMAILFILI;
            END;

            IF @V_OLD_NRDDDFAXFILI  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DDDFax=' + @V_OLD_NRDDDFAXFILI;
            END;

            IF @V_OLD_NRFAXFILISEP  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TelFax=' + @V_OLD_NRFAXFILISEP;
            END;

            IF @V_OLD_NRRAMALFAXFILI  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' RamalFax=' + @V_OLD_NRRAMALFAXFILI;
            END;

            IF @V_OLD_NRDDDTELEFILI	 IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DDDTel1=' + @V_OLD_NRDDDTELEFILI;
            END;

            IF @V_OLD_NRTELEFILISEP	 IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Tel1=' + @V_OLD_NRTELEFILISEP;
            END;

            IF @V_OLD_NRRAMALFILI  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' RamalTel=' + @V_OLD_NRRAMALFILI;
            END;

            IF @V_OLD_NRDDDTELEXFILI  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DDDTel2=' + @V_OLD_NRDDDTELEXFILI;
            END;

            IF @V_OLD_NRTELEXFILISEP  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Tel2=' + @V_OLD_NRTELEXFILISEP;
            END;

            IF @V_OLD_NRRAMTELEXFILI  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' RamalTel2=' + @V_OLD_NRRAMTELEXFILI;
            END;

            IF @V_OLD_DSEMAILEMXMLNFE  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' EmailNFe=' + @V_OLD_DSEMAILEMXMLNFE;
            END;

            SET @V_TIPO   = '3';
            SET @V_ITPESQ = @V_OLD_CDFILIAL;
         END
         ELSE IF @V_IDCOMANDO = 'U' BEGIN /*UPDATING*/
            IF (ISNULL(@V_NEW_CDFILIAL,'!')        <> ISNULL(@V_OLD_CDFILIAL,'!'))        OR
               (ISNULL(@V_NEW_IDTPENDEFILI,'!')    <> ISNULL(@V_OLD_IDTPENDEFILI,'!'))    OR
               (ISNULL(@V_NEW_DSENDEFILISEP,'!')   <> ISNULL(@V_OLD_DSENDEFILISEP,'!'))   OR
               (ISNULL(@V_NEW_NRENDEFILISEP,'!')   <> ISNULL(@V_OLD_NRENDEFILISEP,'!'))   OR
               (ISNULL(@V_NEW_DSCOMPENDFIL,'!')    <> ISNULL(@V_OLD_DSCOMPENDFIL,'!'))    OR
               (ISNULL(@V_NEW_CDLOGRADOURO,'!')    <> ISNULL(@V_OLD_CDLOGRADOURO,'!'))    OR
               (ISNULL(@V_NEW_CDPAIS,'!')          <> ISNULL(@V_OLD_CDPAIS,'!'))          OR
               (ISNULL(@V_NEW_SGESTADO,'!')        <> ISNULL(@V_OLD_SGESTADO,'!'))        OR
               (ISNULL(@V_NEW_CDMUNICIPIO,'!')     <> ISNULL(@V_OLD_CDMUNICIPIO,'!'))     OR
               (ISNULL(@V_NEW_NRCEPFILI,'!')       <> ISNULL(@V_OLD_NRCEPFILI,'!'))       OR
               (ISNULL(@V_NEW_NMCONTFILI,'!')      <> ISNULL(@V_OLD_NMCONTFILI,'!'))      OR
               (ISNULL(@V_NEW_DSEMAILFILI,'!')     <> ISNULL(@V_OLD_DSEMAILFILI,'!'))     OR
               (ISNULL(@V_NEW_NRDDDFAXFILI,'!')    <> ISNULL(@V_OLD_NRDDDFAXFILI,'!'))    OR
               (ISNULL(@V_NEW_NRFAXFILISEP,'!')    <> ISNULL(@V_OLD_NRFAXFILISEP,'!'))    OR
               (ISNULL(@V_NEW_NRRAMALFAXFILI,'!')  <> ISNULL(@V_OLD_NRRAMALFAXFILI,'!'))  OR
               (ISNULL(@V_NEW_NRDDDTELEFILI,'!')   <> ISNULL(@V_OLD_NRDDDTELEFILI,'!'))   OR
               (ISNULL(@V_NEW_NRTELEFILISEP,'!')   <> ISNULL(@V_OLD_NRTELEFILISEP,'!'))   OR
               (ISNULL(@V_NEW_NRRAMALFILI,'!')     <> ISNULL(@V_OLD_NRRAMALFILI,'!'))     OR
               (ISNULL(@V_NEW_NRDDDTELEXFILI,'!')  <> ISNULL(@V_OLD_NRDDDTELEXFILI,'!'))  OR
               (ISNULL(@V_NEW_NRTELEXFILISEP,'!')  <> ISNULL(@V_OLD_NRTELEXFILISEP,'!'))  OR
               (ISNULL(@V_NEW_NRRAMTELEXFILI,'!')  <> ISNULL(@V_OLD_NRRAMTELEXFILI,'!'))  OR
               (ISNULL(@V_NEW_DSEMAILEMXMLNFE,'!') <> ISNULL(@V_OLD_DSEMAILEMXMLNFE,'!')) BEGIN

               IF (ISNULL(@V_NEW_CDFILIAL,'!') <> ISNULL(@V_OLD_CDFILIAL,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' ' + @V_NEW_CDFILIAL;
               END;

               IF @V_NEW_IDTPENDEFILI IS NOT NULL BEGIN
                  IF @V_NEW_IDTPENDEFILI = 'P' BEGIN
                     SET @V_DSTPENDEFILI = '-Principal';
                  END
                  ELSE IF @V_NEW_IDTPENDEFILI = 'C' BEGIN
                     SET @V_DSTPENDEFILI = '-Cobrana';
                  END
                  ELSE IF @V_NEW_IDTPENDEFILI = 'E' BEGIN
                     SET @V_DSTPENDEFILI = '-Exterior';
                  END
                  ELSE BEGIN
                     SET @V_DSTPENDEFILI = '-Exportao';
                  END;
                  SET @V_DESC = @V_DESC + ' TipoEnde=' + @V_NEW_IDTPENDEFILI + @V_DSTPENDEFILI;
               END;

               IF (ISNULL(@V_NEW_DSENDEFILISEP,'!') <> ISNULL(@V_OLD_DSENDEFILISEP,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' DescEndereo=' + @V_NEW_DSENDEFILISEP;
               END;

               IF (ISNULL(@V_NEW_NRENDEFILISEP,'!') <> ISNULL(@V_OLD_NRENDEFILISEP,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Nmero=' + @V_NEW_NRENDEFILISEP;
               END;

               IF (ISNULL(@V_NEW_DSCOMPENDFIL,'!') <> ISNULL(@V_OLD_DSCOMPENDFIL,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Complemento=' + @V_NEW_DSCOMPENDFIL;
               END;

               IF (ISNULL(@V_NEW_CDLOGRADOURO,'!') <> ISNULL(@V_OLD_CDLOGRADOURO,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Logradouro=' + @V_NEW_CDLOGRADOURO;
               END;

               IF (ISNULL(@V_NEW_CDPAIS,'!') <> ISNULL(@V_OLD_CDPAIS,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Pas=' + @V_NEW_CDPAIS;
               END;

               IF (ISNULL(@V_NEW_SGESTADO,'!') <> ISNULL(@V_OLD_SGESTADO,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' SgEstado=' + @V_NEW_SGESTADO;
               END;

               IF (ISNULL(@V_NEW_CDMUNICIPIO,'!') <> ISNULL(@V_OLD_CDMUNICIPIO,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' CdMunicpio=' + @V_NEW_CDMUNICIPIO;
               END;

               IF (ISNULL(@V_NEW_NRCEPFILI,'!') <> ISNULL(@V_OLD_NRCEPFILI,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Cep=' + @V_NEW_NRCEPFILI;
               END;

               IF (ISNULL(@V_NEW_NMCONTFILI,'!') <> ISNULL(@V_OLD_NMCONTFILI,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Contato=' + @V_NEW_NMCONTFILI;
               END;

               IF (ISNULL(@V_NEW_DSEMAILFILI,'!') <> ISNULL(@V_OLD_DSEMAILFILI,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Email=' + @V_NEW_DSEMAILFILI;
               END;

               IF (ISNULL(@V_NEW_NRDDDFAXFILI,'!') <> ISNULL(@V_OLD_NRDDDFAXFILI,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' DDDFax=' + @V_NEW_NRDDDFAXFILI;
               END;

               IF (ISNULL(@V_NEW_NRFAXFILISEP,'!') <> ISNULL(@V_OLD_NRFAXFILISEP,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' TelFax=' + @V_NEW_NRFAXFILISEP;
               END;

               IF (ISNULL(@V_NEW_NRRAMALFAXFILI,'!') <> ISNULL(@V_OLD_NRRAMALFAXFILI,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' RamalFax=' + @V_NEW_NRRAMALFAXFILI;
               END;

               IF (ISNULL(@V_NEW_NRDDDTELEFILI,'!') <> ISNULL(@V_OLD_NRDDDTELEFILI,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' DDDTel1=' + @V_NEW_NRDDDTELEFILI;
               END;

               IF (ISNULL(@V_NEW_NRTELEFILISEP,'!') <> ISNULL(@V_OLD_NRTELEFILISEP,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Tel1=' + @V_NEW_NRTELEFILISEP;
               END;

               IF (ISNULL(@V_NEW_NRRAMALFILI,'!') <> ISNULL(@V_OLD_NRRAMALFILI,'!'))  BEGIN
                   SET @V_DESC = @V_DESC + ' RamalTel=' + @V_NEW_NRRAMALFILI;
               END;

               IF (ISNULL(@V_NEW_NRDDDTELEXFILI,'!') <> ISNULL(@V_OLD_NRDDDTELEXFILI,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' DDDTel2=' + @V_NEW_NRDDDTELEXFILI;
               END;

               IF (ISNULL(@V_NEW_NRTELEXFILISEP,'!') <> ISNULL(@V_OLD_NRTELEXFILISEP,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' Tel2=' + @V_NEW_NRTELEXFILISEP;
               END;

               IF (ISNULL(@V_NEW_NRRAMTELEXFILI,'!') <> ISNULL(@V_OLD_NRRAMTELEXFILI,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' RamalTel2=' + @V_NEW_NRRAMTELEXFILI;
               END;

               IF (ISNULL(@V_NEW_DSEMAILEMXMLNFE,'!') <> ISNULL(@V_OLD_DSEMAILEMXMLNFE,'!')) BEGIN
                   SET @V_DESC = @V_DESC + ' EmailNFe=' + @V_NEW_DSEMAILEMXMLNFE;
               END;

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_OLD_CDFILIAL;
            END;
         END
         ELSE BEGIN /*INSERT*/
            IF (ISNULL(@V_NEW_CDFILIAL,'!') <> ISNULL(@V_OLD_CDFILIAL,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' ' + @V_NEW_CDFILIAL;
            END;

            IF @V_NEW_IDTPENDEFILI IS NOT NULL BEGIN
               IF @V_NEW_IDTPENDEFILI = 'P' BEGIN
                  SET @V_DSTPENDEFILI = '-Principal';
               END
               ELSE IF @V_NEW_IDTPENDEFILI = 'C' BEGIN
                  SET @V_DSTPENDEFILI = '-Cobrana';
               END
               ELSE IF @V_NEW_IDTPENDEFILI = 'E' BEGIN
                  SET @V_DSTPENDEFILI = '-Exterior';
               END
               ELSE BEGIN
                  SET @V_DSTPENDEFILI = '-Exportao';
               END;
               SET @V_DESC = @V_DESC + ' TipoEnde=' + @V_NEW_IDTPENDEFILI + @V_DSTPENDEFILI;
            END;

            IF (ISNULL(@V_NEW_DSENDEFILISEP,'!') <> ISNULL(@V_OLD_DSENDEFILISEP,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' DescEndereo=' + @V_NEW_DSENDEFILISEP;
            END;

            IF (ISNULL(@V_NEW_NRENDEFILISEP,'!') <> ISNULL(@V_OLD_NRENDEFILISEP,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Nmero=' + @V_NEW_NRENDEFILISEP;
            END;

            IF (ISNULL(@V_NEW_DSCOMPENDFIL,'!') <> ISNULL(@V_OLD_DSCOMPENDFIL,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Complemento=' + @V_NEW_DSCOMPENDFIL;
            END;

            IF (ISNULL(@V_NEW_CDLOGRADOURO,'!') <> ISNULL(@V_OLD_CDLOGRADOURO,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Logradouro=' + @V_NEW_CDLOGRADOURO;
            END;

            IF (ISNULL(@V_NEW_CDPAIS,'!') <> ISNULL(@V_OLD_CDPAIS,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Pas=' + @V_NEW_CDPAIS;
            END;

            IF (ISNULL(@V_NEW_SGESTADO,'!') <> ISNULL(@V_OLD_SGESTADO,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' SgEstado=' + @V_NEW_SGESTADO;
            END;

            IF (ISNULL(@V_NEW_CDMUNICIPIO,'!') <> ISNULL(@V_OLD_CDMUNICIPIO,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' CdMunicpio=' + @V_NEW_CDMUNICIPIO;
            END;

            IF (ISNULL(@V_NEW_NRCEPFILI,'!') <> ISNULL(@V_OLD_NRCEPFILI,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Cep=' + @V_NEW_NRCEPFILI;
            END;

            IF (ISNULL(@V_NEW_NMCONTFILI,'!') <> ISNULL(@V_OLD_NMCONTFILI,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Contato=' + @V_NEW_NMCONTFILI;
            END;

            IF (ISNULL(@V_NEW_DSEMAILFILI,'!') <> ISNULL(@V_OLD_DSEMAILFILI,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Email=' + @V_NEW_DSEMAILFILI;
            END;

            IF (ISNULL(@V_NEW_NRDDDFAXFILI,'!') <> ISNULL(@V_OLD_NRDDDFAXFILI,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' DDDFax=' + @V_NEW_NRDDDFAXFILI;
            END;

            IF (ISNULL(@V_NEW_NRFAXFILISEP,'!') <> ISNULL(@V_OLD_NRFAXFILISEP,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' TelFax=' + @V_NEW_NRFAXFILISEP;
            END;

            IF (ISNULL(@V_NEW_NRRAMALFAXFILI,'!') <> ISNULL(@V_OLD_NRRAMALFAXFILI,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' RamalFax=' + @V_NEW_NRRAMALFAXFILI;
            END;

            IF (ISNULL(@V_NEW_NRDDDTELEFILI,'!') <> ISNULL(@V_OLD_NRDDDTELEFILI,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' DDDTel1=' + @V_NEW_NRDDDTELEFILI;
            END;

            IF (ISNULL(@V_NEW_NRTELEFILISEP,'!') <> ISNULL(@V_OLD_NRTELEFILISEP,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Tel1=' + @V_NEW_NRTELEFILISEP;
            END;

            IF (ISNULL(@V_NEW_NRRAMALFILI,'!') <> ISNULL(@V_OLD_NRRAMALFILI,'!'))  BEGIN
                SET @V_DESC = @V_DESC + ' RamalTel=' + @V_NEW_NRRAMALFILI;
            END;

            IF (ISNULL(@V_NEW_NRDDDTELEXFILI,'!') <> ISNULL(@V_OLD_NRDDDTELEXFILI,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' DDDTel2=' + @V_NEW_NRDDDTELEXFILI;
            END;

            IF (ISNULL(@V_NEW_NRTELEXFILISEP,'!') <> ISNULL(@V_OLD_NRTELEXFILISEP,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' Tel2=' + @V_NEW_NRTELEXFILISEP;
            END;

            IF (ISNULL(@V_NEW_NRRAMTELEXFILI,'!') <> ISNULL(@V_OLD_NRRAMTELEXFILI,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' RamalTel2=' + @V_NEW_NRRAMTELEXFILI;
            END;

            IF (ISNULL(@V_NEW_DSEMAILEMXMLNFE,'!') <> ISNULL(@V_OLD_DSEMAILEMXMLNFE,'!')) BEGIN
                SET @V_DESC = @V_DESC + ' EmailNFe=' + @V_NEW_DSEMAILEMXMLNFE;
            END;

            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDFILIAL;
         END;

         IF @V_TIPO <> '0' BEGIN
            IF NOT @V_DESC IS NULL BEGIN
               SET @V_DESC   = SUBSTRING(@V_DESC, 1, 300);
               INSERT INTO LOGOPERA
                  (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO,  CDPESQITEM,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
               VALUES
                  ('ENDEFORN', GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_TIPO, @V_DESC, @V_ITPESQ, @V_DSSERVERRDM,
                   @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER, @V_CDFILLOGOPER);
            END;
         END;

         FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,                                        
                                    @V_OLD_CDFILIAL,       @V_OLD_IDTPENDEFILI, @V_OLD_DSENDEFILISEP,  @V_OLD_NRENDEFILISEP,
                                    @V_OLD_DSCOMPENDFIL,   @V_OLD_CDLOGRADOURO, @V_OLD_CDPAIS,         @V_OLD_SGESTADO,
                                    @V_OLD_CDMUNICIPIO,    @V_OLD_NRCEPFILI,    @V_OLD_NMCONTFILI,     @V_OLD_DSEMAILFILI,
                                    @V_OLD_NRDDDFAXFILI,   @V_OLD_NRFAXFILISEP, @V_OLD_NRRAMALFAXFILI, @V_OLD_NRDDDTELEFILI,
                                    @V_OLD_NRTELEFILISEP,  @V_OLD_NRRAMALFILI,  @V_OLD_NRDDDTELEXFILI, @V_OLD_NRTELEXFILISEP,
                                    @V_OLD_NRRAMTELEXFILI, @V_OLD_DSEMAILEMXMLNFE,

                                    @V_NEW_CDFILIAL,       @V_NEW_IDTPENDEFILI, @V_NEW_DSENDEFILISEP,  @V_NEW_NRENDEFILISEP,
                                    @V_NEW_DSCOMPENDFIL,   @V_NEW_CDLOGRADOURO, @V_NEW_CDPAIS,         @V_NEW_SGESTADO,
                                    @V_NEW_CDMUNICIPIO,    @V_NEW_NRCEPFILI,    @V_NEW_NMCONTFILI,     @V_NEW_DSEMAILFILI,
                                    @V_NEW_NRDDDFAXFILI,   @V_NEW_NRFAXFILISEP, @V_NEW_NRRAMALFAXFILI, @V_NEW_NRDDDTELEFILI,
                                    @V_NEW_NRTELEFILISEP,  @V_NEW_NRRAMALFILI,  @V_NEW_NRDDDTELEXFILI, @V_NEW_NRTELEXFILISEP,
                                    @V_NEW_NRRAMTELEXFILI, @V_NEW_DSEMAILEMXMLNFE;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_ENDEFILI','5.42.xxx';
GO
